/****************************************************************************
*
*   Copyright (c) 2007 www.societyofrobots.com
*   (please link back if you use this code!)
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License version 2 as
*   published by the Free Software Foundation.
*
*   Alternatively, this software may be distributed under the terms of BSD
*   license.
*
*	$50 Robot with Sharp IR using Stampy Technology v1, May 19th, 2007
*	Simple case-based method for a robot to do edge detection.
*
*
****************************************************************************/

//SoR Include
#include "SoR_Utils.h" //includes all the technical stuff

//global variables
int sharp_IR_reading=0;

int scan_thresh=0;//threshold value of scanning sensor

int scan_angle=1000;//position of scanner, in units of servo command
int max_scan_angle=529;//maximum position scanner can rotate to (57)


//this function causes scanning servo to center on edge of object
void scan(void)
	{
	//lower (-) goes right
	//higher (+) goes left
	//30 far right, 50 straight, 56 far left (until it jams)

	/*psuedocode
	object is detected
		scan right object detected
	object not detected
		scan left until object detected*/

	sharp_IR_reading=a2dConvert8bit(3);
	
	if (sharp_IR_reading > scan_thresh)//object detected
		{
		if (scan_angle<529) //overflow protection
			scan_angle+=38;//scan right
		}
	else //object not detected
		{
		if (scan_angle<=max_scan_angle) //maximum servo angle
			scan_angle-=38; //scan left
		//else //if scanned all the way, this forces it to start over
		//	scan_angle=30;
		}
		
	//servo scan code
	servo_scan(scan_angle);
	}


//automatically calculates threshold value before run
void autocalibrate(void)
	{
	scan_thresh=a2dConvert8bit(3);//sensor reading
	}

	/*********ADD YOUR CODE BELOW THIS LINE **********/

	//find thresholds
	autocalibrate();

	while(1)
		{
		scan();
		
		//object on left
		if(scan_angle < 570)
			{//go left
	 		wheel_left=800;
	 		wheel_right=800;
	 		};

		//object on right
		else if(scan_angle > 1000)
			{//go right
			wheel_left=550;
			wheel_right=550;
			};

		//object is centered
		else
			{//go straight
			wheel_left=800;
			wheel_right=550;
	 		}

	
		}
	/*********ADD YOUR CODE ABOVE THIS LINE **********/

	return 0;
	}


/*********************COMMAND LIST*************************

delay_cycles(cycles);
Delays - you can make your robot wait for a certain amount of time with this function.
Put the number of computational cycles to delay in the ().
23 cycles is about .992 milliseconds
to calculate: 23/.992*(time in milliseconds to delay) = cycles
Check servo datasheet where it says: 'Direction: Clockwise/Pulse Traveling 1500 to 1900usec'

servo_left(speed); and servo_right(speed);
Commands your servos to rotate at a certain speed.
Vary speed (which represents a delay in cycles) from 20 to 50.
Left is for port D0 and right is for port D1.

robot_turn_left(); and robot_turn_right(); and robot_go_straight();
Dont want to deal with speed?
Just call this function and it will 'just work.'

LED_on(); and LED_off();
Turns on and off your LED. The LED is on port D4.
By bringing port D4 low, you are turning on the LED.


variable=a2dConvert8bit(pin);
Reads analog pin. For example, set 'pin' to 5 to read PC5.
'variable' will store the value.

***********************************************************/
